diff --git a/src/w32term.c b/src/w32term.c
index bb1f0ba..6e995b7 100644
--- a/src/w32term.c
+++ b/src/w32term.c
@@ -545,6 +1398,15 @@ x_update_begin (struct frame *f)
   if (! FRAME_W32_P (f))
     return;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  f->mc_updating_frame = f;
+
+/* *************************************************************************** */
+
+
   /* Regenerate display palette before drawing if list of requested
      colors has changed. */
   if (display_info->regen_palette)
@@ -754,6 +1616,16 @@ x_update_end (struct frame *f)
 
   /* Mouse highlight may be displayed again.  */
   MOUSE_HL_INFO (f)->mouse_face_defer = false;
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  f->mc_updating_frame = NULL;
+
+/* *************************************************************************** */
+
+
 }
 
 
@@ -4041,13 +4913,74 @@ w32_set_vertical_scroll_bar (struct window *w,
 	      release_frame_dc (f, hdc);
 	      x_clear_under_internal_border (f);
 	    }
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+/* REPAINTING WHEN REMOVING SCROLL BAR:
+
+- Sequence of Events:
+
+  . `redisplay_internal' calls the `condemn_scroll_bars_hook', which marks all
+    scroll bars as candidates for deletion.
+
+  . Then `redisplay_internal' calls `redisplay_windows', which walks the
+    window-tree and examines each window, whereby each window that is still alive
+    in the window-tree "redeems" its scroll bars by marking them not to be
+    deleted.
+
+  . Then `redisplay_internal' calls `judge_scroll_bars_hook', which removes all
+    the scroll bars that were not "redeemed".
+
+  . And only after that `redisplay_internal' calls `update_frame', which calls
+    `update_window' for each live window, and that ends up calling `draw_glyphs'
+    to deliver the updated contents to the glass.
+
+- Observations by @lawlist:
+
+  . Although the call to remove/add scroll bars happens earlier in time, it is
+    not actually processed by Emacs until the tail end of `read_char', at
+    approximately when the call to `read_decoded_event_from_main_queue' occurs.
+
+  . Although a scroll bar may no longer be visible because it was overwritten
+    during `update_window', Emacs tries to remove the outdated scroll bar
+    anyway and that is what erases the fake cursors along the rectangle of the
+    vertical scroll bar.
+
+  . At about the exact same time that the scroll bar in the center of the screen
+    gets erased, the right scroll bar on the far right of the window is added.
+
+- The external function `MoveWindow' (by Microsoft) updates both the old and new
+  rectangles/windows if the boolean argument for `bRepaint` is TRUE.
+
+- The external function `DestroyWindow' (by Microsoft) updates/repaints the
+  rectangle/window that is removed.  [In experimenting with `LockWindowUpdate'
+  (by Microsoft), @lawlist was unable to prevent the update/repaint.]
+
+- The external function `SetWindowPos' (by Microsoft) updates/repaints the
+  rectangle/window that is removed.  @lawlist has not yet experimented with
+  altering the last argument uFlags to see if it is possible to prevent update /
+  repaint.
+
+When a user enlarges the width of a main window, `update_window' redraws the
+screen lines and the old scroll bar window is erased in the process by a
+combination of `draw_glyphs' and `x_clear_end_of_line'.  In that situation, the
+old `bar->left` will be less-than the new `left` scroll bar coordinate.  In order
+to preserve the fake cursors that were laid during `update_window' when
+(left > bar->left), we want to suppress repainting the old scroll.  When a user
+shrinks the width of a window, we want to repaint so that the new scroll bar
+window is updated. */
+
           /* Make sure scroll bar is "visible" before moving, to ensure the
              area of the parent window now exposed will be refreshed.  */
-          my_show_window (f, hwnd, SW_HIDE);
-/**           MoveWindow (hwnd, left, top, width, max (height, 1), TRUE); **/
-	  /* Try to not draw over child frames.  */
-	  SetWindowPos (hwnd, HWND_BOTTOM, left, top, width, max (height, 1),
-                        SWP_FRAMECHANGED);
+          if (left <= bar->left)
+            my_show_window (f, hwnd, SW_HIDE);
+          MoveWindow (hwnd, left, top, width, max (height, 1), left <= bar->left);
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
 
 	  si.cbSize = sizeof (si);
 	  si.fMask = SIF_RANGE;
@@ -4316,6 +5249,21 @@ w32_judge_scroll_bars (struct frame *f)
     {
       struct scroll_bar *b = XSCROLL_BAR (bar);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      /* `DestroyWindow' within `x_scroll_bar_remove' repaints the rectangle.
+      Therefore, we first send a message to inhibit repainting. */
+      if (!WINDOW_LIVE_P (b->window))
+        {
+          HWND hwnd = SCROLL_BAR_W32_WINDOW (b);
+          SendMessage (hwnd, WM_SETREDRAW, false, 0);
+        }
+
+/* *************************************************************************** */
+
+
       x_scroll_bar_remove (b);
 
       next = b->next;
@@ -7091,6 +8039,21 @@ extern frame_parm_handler w32_frame_parm_handlers[];
 
 static struct redisplay_interface w32_redisplay_interface =
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+/* `redisplay_interface' in `w32term.c` must be in the exact same order as the
+`redisplay_interface' in `dispextern.h`! */
+
+  mc_x_write_glyphs,
+  mc_w32_draw_window_cursor,
+  mc_w32_draw_glyph_string,
+
+/* *************************************************************************** */
+
+
   w32_frame_parm_handlers,
   x_produce_glyphs,
   x_write_glyphs,
diff --git a/src/window.h b/src/window.h
index fdef407..f2975be 100644
--- a/src/window.h
+++ b/src/window.h
@@ -88,6 +88,84 @@ display the menu bar or the tool bar (when Emacs uses toolkits that
 don't display their own menu bar and tool bar) or a tooltip in a
 tooltip frame (when tooltips are not display by the toolkit).  */
 
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+/* Suffixes for the `mc` window pointer prefix. */
+struct multiple_cursors
+{
+  /* The recorded pixel width of the last line number drawn during redisplay */
+  int lnum_pixel_width;
+};
+
+struct multiple_cursors_cache
+{
+  ptrdiff_t allocated;
+  ptrdiff_t used;
+  enum type_of_cache
+    {
+      NO_CACHE,
+      MC_CACHE,
+      CH_CACHE,
+      FC_CACHE
+    } cache_type;
+  struct items_in_cache
+    {
+      int x;
+      int fx;
+      int y;
+      int fy;
+      int hpos;
+      int vpos;
+      int wd;
+      int h;
+      enum type_of_cursor
+        {
+          /* NOTE:  The fringe bitmap framework relies upon MC_NO_FRINGE_BITMAP
+          HAVING A VALUE OF ZERO (0). */
+          MC_NO_FRINGE_BITMAP,
+          MC_NO_CURSOR,
+          MC_RIGHT_FRINGE_BITMAP,
+          MC_LEFT_FRINGE_BITMAP,
+          MC_FRAMED_BOX,
+          MC_FILLED_BOX,
+          MC_HOLLOW_BOX,
+          MC_BAR,
+          MC_HBAR
+        } cursor_type;
+      int cursor_width;
+      struct RGB
+        {
+          double red;
+          double green;
+          double blue;
+        } foreground, background;
+      bool active_p;
+      enum mc_flavor
+        {
+          NO_FLAVOR,
+          MC_GLYPH,
+          MC_GLYPHLESS,
+          MC_OVERLAY_ARROW_BITMAP,
+          MC_PILCROW,
+          MC_HOLLOW_RECTANGLE_RIGHT_ARROW,
+          MC_REVERSED_HOLLOW_RECTANGLE_RIGHT_ARROW,
+          MC_HOLLOW_RECTANGLE,
+          MC_VERTICAL_BAR_RIGHT_ARROW,
+          MC_REVERSED_VERTICAL_BAR_RIGHT_ARROW,
+          MC_VERTICAL_BAR,
+          MC_REVERSED_VERTICAL_BAR,
+          MC_VERTICAL_BAR_BACKSLASH
+        } glyph_flavor;
+      bool enabled_p;
+    } *caches;
+};
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 struct cursor_pos
 {
   /* Pixel position.  These are always window relative.  */
@@ -324,6 +402,21 @@ struct window
 
 #ifdef HAVE_WINDOW_SYSTEM
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+    struct multiple_cursors mc;
+
+    struct multiple_cursors_cache mc_elts;
+
+    struct multiple_cursors_cache ch_elts;
+
+    struct multiple_cursors_cache fc_elts;
+
+/* *************************************************************************** */
+
+
     /* Cursor type of last cursor drawn on the window.  */
     enum text_cursor_kinds phys_cursor_type;
 
@@ -1120,6 +1213,15 @@ extern void redisplay_other_windows (void);
 
 struct glyph *get_phys_cursor_glyph (struct window *w);
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+struct glyph *mc_get_cursor_glyph (struct window *w, struct glyph_matrix *matrix, struct glyph_row *row, int hpos, int vpos);
+
+/* *************************************************************************** */
+
+
 /* True if WINDOW is a valid window.  */
 #define WINDOW_VALID_P(WINDOW)					\
   (WINDOWP (WINDOW) && !NILP (XWINDOW (WINDOW)->contents))	\
